import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.LinkedList;
import java.util.ArrayList;

/**
 * Write a description of class TestWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TestWorld  extends World
{
    Slingshot s = new Slingshot();
    boolean pelletadded = false;
    boolean shotloaded = false;
    LinkedList <Pellet> pellets = new LinkedList();
    InputBox gravity = new InputBox("Gravity (0-10)",0,10,0.6,18,1);
    InputBox eforce = new InputBox("Force Constant (0-1)",0,2,0.4,18,2);
    InputBox mass = new InputBox("Mass (1-100)",0,100,5,18,3);
    InputBox airfric = new InputBox("Air Friction (0-2)",0,2,0.1,18,4);
    InputBox wind = new InputBox("Wind (0-10)",0,10,0.0,18,5);
    Dial dial = new Dial();
    Instructions intructions = new Instructions();
    AboutButton btn = new AboutButton();
    CollisionInfo info = new CollisionInfo();
    
    ArrayList<Dot> dots = new ArrayList(); // these are the dots the pellet leaves behind
    double pelletmass = 5;
    boolean paused = false;
    double grav = 0.6; // tell the pellets what gravity is
    double airfriction = 0.1;
    Vect windVect = new Vect(0,0);
    // testing variables
    boolean test1 = false;
    boolean test2 = false;
    double testnum;
    Vect testVect;
    
    /**
     * Constructor for objects of class TestWorld.
     * 
     */
    public TestWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        
        super(600, 400, 1); 
        setPaintOrder(InfoSign.class,Slingshot.class,Pellet.class,Strap.class,DialPart.class,Arrow.class,Dial.class);
        addPellets();
        addObject(s,130,350 - s.getImage().getHeight()/2);
        addObject(gravity,80,30);
        addObject(eforce,80,80);
        addObject(mass,80,130);
        addObject(airfric,80,180);
        addObject(btn,538,375);
        addObject(wind,232,30);
        addObject(dial,232,109);
        addObject(new ScreenText(),231,183);
        addObject(new Instructions(),144,380);
        addObject(info,344,370);
    }
    
    public void act() {
        
        // added a pause feture, to keep things from getting too mixed up.
        if(!paused) {
            if (!shotloaded) {
                sendToSShot(pellets.element()); // the pellet at the front of the line.  Send it to the shot
                shotloaded = true;
            }
        }
        
        // add some targets to shoot at
        if (Greenfoot.getRandomNumber(100) == 1) {
            addObject(new SimpleTarget(),0,0);
        }
    }
    
    public void addPellets() {
        for (int i = 0 ; i < 5; i++) {
            Pellet p = new Pellet();
            pellets.add(p);
            addObject(p,5*15-(i)*15,350-p.getImage().getHeight()/2);
        }
        // pellet at index 4 is at the front of the line.  I wish I could use a queue here.. maybe I can
        // move the first pellet to the 
        pellets.element().sendToSShot();
        sendToSShot(pellets.element());
    }
    
    // puts the pellet at the head of the list into the slingshot.  Also gives the slingshot a reference 
    // to the pellet.
    public void sendToSShot(Pellet p) {
        p.setGravity(grav);
        p.setAirFriction(airfriction);
        p.sendToSShot();
        p.setMass(pelletmass);
        //windVect.scalarMultiply(-1); // for some reason it's all backward.  Just multiply by -1 though
        p.setWind(windVect); 
        s.addPellet(p);
    }
    
    public void addAnotherPellet() {
        // so remove the pellet at the first part of the list, and add another pellet at the back of the list
        pellets.removeFirst();
        Pellet p = new Pellet(); // make a new pellet
        addObject(p,0,350-p.getImage().getHeight()/2); // add it to the world..
        pellets.addLast(p); // add it to the end of the list
        // now move 'em right...
        moveRight();
        shotloaded = false; // and then tell the act() function to load another shot...
    }
    
    public void moveRight() {
        for (Pellet p: pellets) {
            p.moveRight(1,15);
        }
    }
    /**
     * This method gets input from the inputbox class.  The boxnum indicates how to interpet this input.
     */
    public void getInput(int boxnum, double input) {
        switch (boxnum) {
            case 1: // this is the gravity one. Gravity is a static int in the PHYX class
            // actually ended up changing gravity through the pellet, because it's easier that way 
            // the variable grav gets sent to each pellet as they are loaded into the slingshot
            /*Phyx.setGravity(input); test1 = true; testVect = Phyx.Gravity(); */grav = input;
            break; 
            case 2: // this sets how hard the slingshot accelerates the pellet
            s.setElasticNum(input); test2 = true;
            break;
            case 3: // this sets the mass of the pellet.  
            pelletmass = input;
            break;
            case 4: // this one sets the Air Friction.  Doesn't do anything yet...
            airfriction = input; // now it does!
            break;
            case 5: // sets the wind vector.
            windVect = dial.getVect(input); // ok so the wind input box sets this.  This also needs to happen
            // whenever the dial gets moved as well.  So that happens in a different method.
            windVect.scalarMultiply(-1); // for some reason it's all backward.  Just multiply by -1 though
            break;
        }
    }
     // the dial sets this...
    public void setWind() {
        windVect = dial.getVect(wind.whatIsInput());
        windVect.scalarMultiply(-1); // for some reason it's all backward.  Just multiply by -1 though
    }
    
    public void Pause() {
        paused = true;
    }
    
    public void unPause() {
        paused = false;
    }
    // the pellet does this
    public void addDot(int x,int y,int size) {
        Dot d = new Dot(size);
        addObject(d,x,y);
        dots.add(d);
    }
    // the slingshot does this
    public void removeDots() {
        for (Dot d:dots) {
            removeObject(d);
        }
        dots.clear();
    }
    
    public void displayCollisionData(int angle, int velocity,int x, int y) {
        info.drawInfo(angle,velocity,x,y);
    }
}
